import { randomValueFromArray } from '../utils/Random';

export function selectSource(creep: Creep): Id<Source> {
  const sources = creep.room.find(FIND_SOURCES);
  const choices: Array<String> = [];
  for (let source of sources) {
    const weight = getSourceWeight(source);
    for (let i = 0; i < weight; ++i) {
      choices.push(source.id);
    }
  }
  console.log('Sources', choices);
  return randomValueFromArray(choices) as Id<Source>;
}

function getSourceWeight(source: Source) {
  const pos = source.pos;
  const terrains = source.room.lookForAtArea(LOOK_TERRAIN, pos.y - 1, pos.x - 1, pos.y + 1, pos.x + 1, true);
  const walked = terrains.filter((t) => t.terrain !== 'wall');
  return Math.max(walked.length - 1, 1);
}
